/* global BDF,$$,ScrutariExport */

ScrutariExport.List = {};

ScrutariExport.List.init = function (callback) {
    BDF.Ajax.loadScrutariExportArray(function (scrutariExportArray) {
        scrutariExportArray = ScrutariExport.initArray(scrutariExportArray);
        let $listBody = $$("listpane_body");
        $listBody.html(BDF.render("scrutariexport:list/scrutariexport", scrutariExportArray));
        BDF.Deploy.init($listBody);
        ScrutariExport.List.initActions();
        if (callback) {
            callback();
        }
    });
};

ScrutariExport.List.initActions = function () {
    $$("listpane_button_newscrutariexport").click(ScrutariExport.Overlay.showCreationForm);
    var $body = $$("listpane_body");
    BDF.onClick($body, {action: "metadata"}, function () {
        if (!BDF.confirmUnload()) {
            return false;
        }
        let name = BDF.Pane.getEntryName(this);
        BDF.Pane.loadOrDestock(name, function () {
            ScrutariExport.Form.load(name);
        });
    });
    BDF.onClick($body, {action: "run"}, function () {
        ScrutariExport.Overlay.showRun(BDF.Pane.getEntryName(this));
    });
    BDF.onClick($body, {action: "scrutariexportremove"}, function () {
        ScrutariExport.Overlay.showRemoveConfirm(BDF.Pane.getEntryName(this));
    });
};

ScrutariExport.List.updateScrutariExport = function (newScrutariExport) {
    var $currentScrutariExport =  BDF.$({role: "entry", name: newScrutariExport.name});
    BDF.$($currentScrutariExport, {role: "entry-title"}).html(newScrutariExport.title);
};